\ 
\ Last_change: KS 02.10.2011 16:28:40
\ 
Forth definitions
\ -----------------------------------------------------------------------------
\ Basic Objects: Cell, Buffer, String
\ -----------------------------------------------------------------------------

Class Cell   Cell definitions

1 cells Self allot

Self seal

>: @    ( obj -- n )   @ ;
                          
>: !    ( n obj -- )   ! ;
                          
>: +!   ( n obj -- )   +! ;
                          
>: on   ( obj -- )     on ;
                          
>: off  ( obj -- )     off ;

>: ?    ( obj -- )     @ . ;

Forth definitions

Class Buffer   Buffer definitions

Cell :: Ptr
Cell :: Len

Self seal
 
>: size   ( obj -- +n )         Self Len @ ;

>: addr   ( obj -- buf.addr )   Self Ptr @ ?dup 0= ABORT" uninitialized_buffer" ;
 
>: allot  ( +n obj -- )
   dup Self Ptr @ IF  Self Len @ u> ABORT" buffer_too_small"  EXIT THEN
   here over Self Ptr !   over swap Self Len !   allot
;
>: update ( addr +n obj -- )    dup >r Self Len !  r> Self Ptr ! ;

>: reset  ( obj -- )            >r 0 0 r> Self update ;

>: ?      ( obj -- )            dup @ ." addr " u.  cell+ @ ." length " u. ;

Forth definitions

class String   String definitions

Buffer :: String

Self seal

>: size  ( obj -- +n )          Self String size 1- ;

>: ?size ( +n obj -- +n )
   Self size over < ABORT" string_overflow" ;

>: @     ( obj -- c-addr +n )   Self String addr count ;

>: chars ( obj -- +n )          Self @ nip ;

>: !     ( c-addr +n obj -- )   >r r@ Self ?size r> Self String addr place ;

>: ?     ( obj -- )             Self @ type ;

>: init  ( +n obj -- )
    >r &255 umin 1+ r@ Self String allot
    r> Self String addr off
;
>: +!    ( c-addr +n obj -- )
    >r r@ Self chars  2dup +  r@ Self ?size  ( addr +n chars newsize )
    dup >r   swap - umin                     ( addr +n' )
    r>   r@ Self @ +                         ( addr +n' newsize addr+ )
    swap r> Self String addr c! \ set new length ( addr +n' addr+ )
    swap move               \ append string
;

Forth definitions
\ -----------------------------------------------------------------------------
\ testing
\ -----------------------------------------------------------------------------

String New s1   20 s1 init
String New s2   20 s2 init
Create dies ," drhn"  dies count s1 !
Create das  ," blah"    das count s2 !

: stringtest  ( -- )  s1 @ s2 +!   s2 ? ;

Class Indirect  Indirect definitions
Cell :: Zahl
Cell [] Ref     Self seal

Forth definitions

Class Refref Refref definitions

Indirect :: Indir

Self seal

Forth definitions

Cell     New Zelle
Indirect New Ind
Refref   New Deeper

: deep-assign ( xt -- )  BIND Deeper Indir Ref ;

: init  ( -- object )   ." loading " ['] Zelle BIND Ind Ref   Ind Ref .. ;
' init BIND Ind Ref

String definitions

Method: ??     \ a dummy definition, which is needed to compile WITH-DUMMY below

Forth definitions

: with-dummy ( -- )   s1 ?? ;

\\ Later, ?? can be defined as meaningful string method, e.g.:
String definitions

>: ??  dup Self ? Self ? ;

Forth definitions
